{% extends '@KaitekFramework/Default/myjui.html.twig' %}
{% trans_default_domain 'FOSUserBundle' %}
{% block body %}{% endblock %}
{% block javascripts %}
    {{ parent() }}
    <script type="application/javascript">
        $(function() {
            window.app = {
                menuItems: {{ menu|json_encode()|raw }},
                editModule: {{ editModule|json_encode()|raw }},
                documentId: {% if documentId is empty %} false {% else %} {{ documentId }} {% endif %},
                docTypeEntityId: {% if docTypeEntityId is empty %} false {% else %} {{ docTypeEntityId }} {% endif %},
                editRecordId: {% if id is empty %} false {% else %} {{ id }} {% endif %},
                initHash: location.hash.replace('#', ''),
                editRecord: function(item, focusField, recordId, documentId){
                    window.tmpModule = item;
                    var winDesktopId = item.multiplewindow ? mj.genId('win') : item.id;
                    var windowConfig = {
                        app: app,
                        cls: typeof item.cls !== 'undefined' ? item.cls : '',
                        destroyOnClose: true,
                        minimizable: typeof item.minimizable !== 'undefined' ? item.minimizable : true,
                        maximizable: typeof item.maximizable !== 'undefined' ? item.maximizable : true,
                        closable: typeof item.closable !== 'undefined' ? item.closable : true,
                        resizable: typeof item.resizable !== 'undefined' ? item.resizable : true,
                        wM: app.desktop.wM,
                        id: item.modulename,
                        parent: app.desktop.body,
                        renderTo: app.desktop.body,
                        modal: item.modal,
                        title: item.fullTitle || item.title,
                        width: item.width || app.desktop.defaultWindowWidth,
                        height: item.height || app.desktop.defaultWindowHeight,
                        minWidth: item.minWidth || item.width,
                        minHeight: item.minHeight || item.height,
                        buttons: item.buttons
                    };
                    if(typeof Routing != 'undefined'){
                        windowConfig.autoLoad = {
                            url: (typeof Routing != 'undefined' ? Routing.generate(item.modulename + "-open-record", {
                                'id': recordId,
                                'focusField': focusField
                            }) : ''),
                            modulename: item.modulename,
                            menuId: item.id
                        };
                        windowConfig._onLoad = function(){
                            var win = this;
                            win.mask.show();
                            setTimeout(function(){
                                win.mask.hide();
                                var m = win.obj;
                                m.grids.main.selectRow(m.grids.main, 0, false);
                                if(!documentId) {
                                    m.editSelectedRecord();
                                    var f = m.forms.main.getField(focusField);
                                    if (f) {
                                        setTimeout(function () {
                                            f.focus();
                                        }, 300);
                                    }
                                } else {
                                    if(m.documentation){
                                        m._onLoadOnce = function(){
                                            m.stores.documentation.mon('load', m._onLoadOnce);
                                            var v = m.documentation.view;
                                            for(var i = 0; i<v.items.length; i++){
                                                var item = v.items[i];
                                                if(app.documentId == item.store.id){
                                                    m.documentation._onViewItemClick(v, item, false);
                                                    var f = m.documentation.form.getField(focusField);
                                                    if (f) {
                                                        setTimeout(function () {
                                                            f.focus();
                                                        }, 300);
                                                    }

                                                }
                                            }
                                        };
                                        m.stores.documentation.on('load', m._onLoadOnce, m);

                                        m.documentation.docTypeEntityId = app.docTypeEntityId;
                                        m.documentation.activateTabDocument();

                                    }
                                }
                            }, 250);
                        };
                    }
                    tmpModule.win = new mj.window(windowConfig);
                    tmpModule.win.on('close',function(x,y){
                        var t=this;
                        delete window[item.modulename];
                        //win.tab.remove();
                        this.winHistory.remove(x.winDesktopId);//?
                        this.windows[item.multiplewindow?x.winDesktopId:x.id]=null;
                        if(this.winHistory.length>0&&!this.windows[this.winHistory[this.winHistory.length-1]].window.minimized)
                            this.windows[this.winHistory[this.winHistory.length-1]].window.show();
                    }, app.desktop);
                    tmpModule.win.show();
                    return tmpModule.win;
                },
                start: function(_name, _role, _avatar, _loginId) {
                    app.desktop = new mj.desktop({
                        renderTo: mj.bd,
                        app: app,
                        fixedSideNav: true,
                        logo: '<svg class="brand-logo-img" height="35" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 275 69"><g fill="#ffffff"><path d="M164.146 55.664h-4.99c-4.28 0-7.903-1.524-10.86-4.57-2.963-3.047-4.444-6.713-4.444-10.99V12.078c0-2.98-1.07-5.542-3.21-7.684-2.' +
                                '143-2.14-4.705-3.21-7.69-3.21v38.92c0 7.173 2.575 13.28 7.72 18.316 5.146 5.043 11.312 7.56 18.486 7.56h15.37c0-2.857-1.016-5.288-3.05-7.298-2.033-2.013-4.472-3.018-7.332-3.018z"/><path d="M155.525 34.13h2.33c2.855 0 5.3-1.002 7.33-3.013 2.033-2.012 ' +
                                '3.05-4.444 3.05-7.297h-12.71c-1.432 0-2.65.51-3.66 1.522-1.022 1.02-1.528 2.24-1.528 3.665 0 1.426.506 2.636 1.527 3.634 1.01.996 2.23 1.49 3.66 1.49zM183.8 21.71c-5.15 5.087-7.72 11.21-7.72 18.394 0 7.173 2.57 13.28 7.72 18.316 5.146 5.043 11.31 7.5' +
                                '6 18.483 7.56h15.37c0-2.857-1.017-5.288-3.044-7.298-2.033-2.013-4.478-3.018-7.33-3.018h-4.997c-4.232 0-7.846-1.535-10.832-4.6-2.98-3.074-4.47-6.727-4.47-10.96 0-4.242 1.49-7.916 4.47-11.035 2.987-3.11 6.6-4.667 10.833-4.667h4.996c2.853 0 5.296-1.005 ' +
                                '7.33-3.013 2.026-2.015 3.044-4.447 3.044-7.302h-15.37c-7.175 0-13.34 2.542-18.483 7.623z"/><path d="M194.99 36.346c-.973 1.003-1.46 2.243-1.46 3.72 0 1.44.495 2.646 1.49 3.62.993.98 2.204 1.473 3.632 1.473h8.627c2.853 0 5.297-1 7.33-3.005 2.028-1.998' +
                                ' 3.044-4.438 3.044-7.306h-19c-1.47 0-2.695.498-3.665 1.496zM269.705 31.442c1.885-3.656 2.818-7.56 2.818-11.71V14.87h-10.896v4.862c0 4.24-1.49 7.914-4.476 11.03-2.98 3.11-6.595 4.664-10.83 4.664h-14.396v-23.35c0-2.98-1.07-5.542-3.213-7.684-2.14-2.14-4' +
                                '.7-3.21-7.687-3.21v64.794h10.9V45.742h14.395c4.236 0 7.85 1.554 10.832 4.67 2.983 3.11 4.475 6.784 4.475 11.023v4.54h10.895v-4.54c0-4.105-.934-7.99-2.817-11.643-1.88-3.656-4.484-6.712-7.813-9.176 3.33-2.464 5.936-5.52 7.815-9.174zM42.912 19.732c0 4.2' +
                                '4-1.49 7.914-4.472 11.03-2.98 3.11-6.594 4.664-10.83 4.664h-14.4v-23.35c0-2.98-1.07-5.542-3.212-7.684-2.137-2.14-4.702-3.21-7.684-3.21v64.794H13.21V45.742h14.4c4.236 0 7.85 1.554 10.83 4.67 2.98 3.11 4.472 6.784 4.472 11.023v4.54h10.9v-4.54c0-4.105-.' +
                                '945-7.99-2.82-11.643-1.883-3.656-4.49-6.712-7.817-9.176 3.328-2.467 5.935-5.524 7.818-9.177 1.874-3.657 2.818-7.562 2.818-11.71v-4.863H42.913v4.865zM85.267 14.09c-7.177 0-13.352 2.54-18.52 7.62-5.162 5.087-7.746 11.21-7.746 18.394 0 7.173 2.585 13.28' +
                                ' 7.748 18.316 5.167 5.043 11.342 7.56 18.52 7.56H111.6V40.103c0-7.184-2.593-13.307-7.782-18.393-5.19-5.08-11.374-7.62-18.55-7.62zm15.307 41.574h-15.34c-4.29 0-7.917-1.524-10.89-4.57-2.967-3.047-4.45-6.713-4.45-10.99 0-4.288 1.483-7.97 4.45-11.062 2.9' +
                                '73-3.092 6.6-4.64 10.89-4.64 4.287 0 7.92 1.548 10.887 4.64 2.968 3.092 4.454 6.773 4.454 11.062v15.56zM124.278 17.305c-2.14-2.145-4.7-3.216-7.688-3.216v40.996c0 2.98 1.075 5.545 3.212 7.68 2.14 2.144 4.702 3.213 7.688 3.213V24.986c0-2.982-1.07-5.544' +
                                '-3.212-7.682zm.258 13.067c-.668.693-1.5 1.032-2.498 1.032-.993 0-1.82-.34-2.493-1.032-.673-.69-1.003-1.533-1.003-2.53 0-.952.33-1.774 1.003-2.465.673-.693 1.5-1.04 2.493-1.04.998 0 1.83.347 2.498 1.04.673.69 1.007 1.513 1.007 2.464 0 1-.334 1.842-1.0' +
                                '07 2.532z"/></g></svg>',
                        userDetailsBg: '<img style="width:100%" src="{{ asset('img/material-bg-1.jpg') }}" alt="" />',
                        user: {
                            avatar: _avatar,
                            name: _name,
                            role: _role
                        },
                        menuItems: app.menuItems
                        , destroy: function(){
                            var t=this;
                            t.renderTo.removeClass('mj-desktop fixed-side-nav');
                            t.actionBar.destroy();
                            t.sideNav.destroy();
                            t.mask.destroy();
                            mj.desktop.superclass.destroy.call(this);
                        }
                    });
                    app.desktop.actionBar.destroyEl = app.desktop.actionBar.el;
                    app.desktop.sideNav.destroyEl = app.desktop.sideNav.el;
                    app.desktop.destroyEl = app.desktop.body;




                    if(app.editModule){
                        app.editRecord(app.editModule
                            , '{{ focusField }}'
                            , app.editRecordId
                            , app.documentId
                        );
                    }





                },
                logout : function() {
                    app.desktop.mask.show();
                    $.ajax({
                        url: '{{ path("kaitek_framework_xhr_logout") }}',
                        method: 'POST',
                        dataType: 'json',
                        success: function(_data, textStatus, jqXHR) {
                            if(_data.success){
                                app.csrf_input.setValue(_data._csrf_token);
                                app.loginBtn.setEnable();
                                app.desktop.destroy();
                                app.loginCnt.show();
                                app.loginCnt.removeClass("bounceOutRight").addClass("animated bounceInRight");
                            }
                        },
                        error: function(jqXHR, textStatus, errorThrown) {
                            mj.message({title: mj.lng.glb.error, text: jqXHR.responseJSON.message, type: "error", html: true});
                        },
                        complete: function(jqXHR, textStatus) {
                        }
                    });
                },
                reload : function(){
                    document.location.reload();
                }
            };
            var loginFormVisibility = "";
            {% if is_granted("IS_AUTHENTICATED_REMEMBERED") %}
                app.start('{{ last_username }}', '&nbsp;', '{{ asset('img/anonymous.png') }}', '{{ loginId }}');
                loginFormVisibility = 'style="display:none"';
            {% endif %}
            app.loginCnt = $('<div class="row"'+loginFormVisibility+'></div>').appendTo(document.body);
            var el = $('<div class="col right" style="width:300px;margin:30px;"></div>').appendTo(app.loginCnt);
            el = $('<div class="card grey lighten-5"></div>').appendTo(el);
            app.loginFormCnt = $('<div class="card-content"></div>').appendTo(el);

            {% block loginFormLogo %}
            $('<div class="row"><div class="col s12 center-align"><img class="responsive-img" style="height:100px" src="{{ asset('img/anonymous.png') }}" alt="" /></div></div>').appendTo(app.loginFormCnt);
            {% endblock %}


            app.loginForm = new mj.form({
                renderTo: app.loginFormCnt,
                items: [
                    new mj.form.textField({
                        title: "{{ 'security.login.username'|trans }}",
                        id: '_username',
                        dataIndex: '_username',
                        iconcls: 'fa-user',
                        validationErrorMessage: "{{ 'security.login.please_enter_valid_username'|trans({}, 'KaitekFrameworkBundle') }}",
                        required: true
                    }),
                    new mj.form.passField({
                        title: "{{ 'security.login.password'|trans }}",
                        id: '_password',
                        dataIndex: '_password',
                        iconcls: 'fa-key',
                        validationErrorMessage: "{{ 'security.login.please_enter_valid_password'|trans({}, 'KaitekFrameworkBundle') }}",
                        required: true
                    }),
                    //new mj.form.checkBox({
                    //    title : "{{ 'security.login.remember_me'|trans }}",
                    //    id : 'rememberme',
                    //    dataIndex : '_csrf_token',
                    //    dataIndex : 'rememberme'
                    //}),
                    app.csrf_input = new mj.form.field({title: '_csrf_token', dataIndex: '_csrf_token', hidden: true, initValue: "{{ csrf_token }}", required: true}),
                    new mj.form.textField({
                        id: 'editRecordId',
                        dataIndex: 'editRecordId',
                        initValue: app.editRecordId,
                        hidden: true
                    }),
                    new mj.form.textField({
                        id: 'editModule',
                        dataIndex: 'editModule',
                        initValue: '{{ module }}',
                        hidden: true
                    }),
                    new mj.form.textField({
                        id: 'focusField',
                        dataIndex: 'focusField',
                        initValue: '{{ focusField }}',
                        hidden: true
                    })
                ]
            });

            var loginId = mj.getCookie('loginId');
            if (loginId !== null) {
                app.loginForm.items[0].setValue(loginId);
                app.loginForm.items[0].trigger('blur', app.loginForm.items[0], app.loginForm.items[0]);
                //app.loginForm.items[1].input.focus();
            }
            //else    app.loginForm.items[0].input.focus();

            var row = $('<div class="row" style="margin-bottom:0;"></div>').appendTo(app.loginFormCnt);
            var col = $('<div class="col s12"></div>').appendTo(row);
            app.loginBtn = new mj.button({
                title: "{{ 'security.login.submit'|trans }}",
                renderTo: col,
                cls: 'col s12',
                handler: function() {
                    this.setDisable();
                    app.loginForm.submit({
                        url: "{{ path("fos_user_security_check", {'_locale': app.request.attributes.get('_locale')}) }}",
                        success: function(data) {
                            mj.setCookie('loginId', app.loginForm.items[0].getValue(), 365, '/');
                            if (data && data.success) {
                                app.menuItems = data.menu;
                                app.editModule = data.editModule;
                                app.loginCnt.one('animationend', function() {
                                    app.loginCnt.hide();
                                    app.start(data._name, data._role, data._avatar
                                        ? data._avatar
                                        : '{{ asset('img/anonymous.png') }}', data._loginId);
                                });
                                app.loginCnt.addClass("animated bounceOutRight");
                            } else if (data && data.success == false && data.message){
                                mj.message("{{ 'err.main.error_message'|trans({}, 'KaitekFrameworkBundle') }}", data.message, "error");
                            } else {
                                mj.message("{{ 'err.main.error_message'|trans({}, 'KaitekFrameworkBundle') }}", "{{ 'err.main.message_title'|trans({}, 'KaitekFrameworkBundle') }}", "error");
                            }
                        },
                        error: function(data) {
                            mj.message("{{ 'err.main.error_message'|trans({}, 'KaitekFrameworkBundle') }}", data.responseJSON.message, "error");
                            app.csrf_input.setValue(data.responseJSON.token);
                            app.loginBtn.setEnable();
                        }
                    });
                }
            });
            $('input#_username').bind('keydown', {
                sc: app.loginForm.items[0]
            }, function(e) {
                var el = app.loginForm.items[0],
                    nEl = app.loginForm.items[1];
                if (e.keyCode == 13 && (el.getValue() != '' || el.input.val() != '')) {
                    el.input.removeClass('focus');
                    el.trigger('blur', el, el);
                    nEl.input.focus();
                }
            });
            $('input#_password').bind('keydown', {
                sc: app.loginForm.items[1]
            }, function(e) {
                var el = app.loginForm.items[0],
                    pEl = app.loginForm.items[1];
                if (e.keyCode === 13 && el.getValue() !== '' && pEl.getElValue() !== '') {
                    pEl.input.removeClass('focus');
                    pEl.trigger('blur', pEl, pEl);
                    app.loginBtn.handler();
                }
            });
        });
    </script>
{% endblock %}
